diff --git a/drivers/net/af_packet/meson.build b/drivers/net/af_packet/meson.build
index 92c306c73..a7f392ea1 100644
--- a/drivers/net/af_packet/meson.build
+++ b/drivers/net/af_packet/meson.build
@@ -3,5 +3,6 @@
 
 if not is_linux
 	build = false
+	reason = 'only supported on linux'
 endif
 sources = files('rte_eth_af_packet.c')
diff --git a/drivers/net/af_xdp/meson.build b/drivers/net/af_xdp/meson.build
index 7904840f0..ac679b92b 100644
--- a/drivers/net/af_xdp/meson.build
+++ b/drivers/net/af_xdp/meson.build
@@ -13,4 +13,5 @@ if bpf_dep.found() and cc.has_header('bpf/xsk.h') and cc.has_header('linux/if_xd
 	pkgconfig_extra_libs += '-lbpf'
 else
 	build = false
+	reason = 'missing dependency, "libbpf"'
 endif
diff --git a/drivers/net/avp/meson.build b/drivers/net/avp/meson.build
index 8138cb22d..a5f63cdef 100644
--- a/drivers/net/avp/meson.build
+++ b/drivers/net/avp/meson.build
@@ -2,7 +2,8 @@
 # Copyright(c) 2018 Intel Corporation
 
 if not is_linux
-        build = false
+	build = false
+	reason = 'only supported on linux'
 endif
 sources = files('avp_ethdev.c')
 install_headers('rte_avp_common.h', 'rte_avp_fifo.h')
diff --git a/drivers/net/axgbe/meson.build b/drivers/net/axgbe/meson.build
index 6decb25d4..86873b7ef 100644
--- a/drivers/net/axgbe/meson.build
+++ b/drivers/net/axgbe/meson.build
@@ -3,6 +3,7 @@
 
 if not is_linux
 	build = false
+	reason = 'only supported on linux'
 endif
 
 sources = files('axgbe_ethdev.c',
diff --git a/drivers/net/bnx2x/meson.build b/drivers/net/bnx2x/meson.build
index dd189ffc4..4892bb234 100644
--- a/drivers/net/bnx2x/meson.build
+++ b/drivers/net/bnx2x/meson.build
@@ -3,6 +3,7 @@
 
 dep = dependency('zlib', required: false)
 build = dep.found()
+reason = 'missing dependency, "zlib"'
 ext_deps += dep
 cflags += '-DZLIB_CONST'
 sources = files('bnx2x.c',
diff --git a/drivers/net/dpaa/meson.build b/drivers/net/dpaa/meson.build
index 8e5418bd6..94c0e22c5 100644
--- a/drivers/net/dpaa/meson.build
+++ b/drivers/net/dpaa/meson.build
@@ -3,6 +3,7 @@
 
 if not is_linux
 	build = false
+	reason = 'only supported on linux'
 endif
 deps += ['mempool_dpaa']
 
diff --git a/drivers/net/dpaa2/meson.build b/drivers/net/dpaa2/meson.build
index a0ea99238..7e74c656a 100644
--- a/drivers/net/dpaa2/meson.build
+++ b/drivers/net/dpaa2/meson.build
@@ -4,7 +4,8 @@
 version = 2
 
 if not is_linux
-        build = false
+	build = false
+	reason = 'only supported on linux'
 endif
 
 deps += ['mempool_dpaa2']
diff --git a/drivers/net/enetc/meson.build b/drivers/net/enetc/meson.build
index 7d0c2ffe7..3bc069844 100644
--- a/drivers/net/enetc/meson.build
+++ b/drivers/net/enetc/meson.build
@@ -3,6 +3,7 @@
 
 if not is_linux
 	build = false
+	reason = 'only supported on linux'
 endif
 
 sources = files('enetc_ethdev.c',
diff --git a/drivers/net/ifc/meson.build b/drivers/net/ifc/meson.build
index 72df070ac..adc9ed9ff 100644
--- a/drivers/net/ifc/meson.build
+++ b/drivers/net/ifc/meson.build
@@ -2,6 +2,7 @@
 # Copyright(c) 2018 Intel Corporation
 
 build = dpdk_conf.has('RTE_LIBRTE_VHOST')
+reason = 'missing dependency, DPDK vhost library'
 allow_experimental_apis = true
 sources = files('ifcvf_vdpa.c', 'base/ifcvf.c')
 includes += include_directories('base')
diff --git a/drivers/net/kni/meson.build b/drivers/net/kni/meson.build
index e3b2d83b5..0539b4768 100644
--- a/drivers/net/kni/meson.build
+++ b/drivers/net/kni/meson.build
@@ -3,5 +3,6 @@
 
 # this driver can be built if-and-only-if KNI library is buildable
 build = dpdk_conf.has('RTE_LIBRTE_KNI')
+reason = 'missing dependency, DPDK KNI library'
 sources = files('rte_eth_kni.c')
 deps += 'kni'
diff --git a/drivers/net/mlx4/meson.build b/drivers/net/mlx4/meson.build
index 2540489bb..5de04b70b 100644
--- a/drivers/net/mlx4/meson.build
+++ b/drivers/net/mlx4/meson.build
@@ -25,6 +25,7 @@ foreach libname:libnames
 		libs += [ lib ]
 	else
 		build = false
+		reason = 'missing dependency, "' + libname + '"'
 	endif
 endforeach
 # Compile PMD
diff --git a/drivers/net/mlx5/meson.build b/drivers/net/mlx5/meson.build
index ac3b529d1..22ddd54c2 100644
--- a/drivers/net/mlx5/meson.build
+++ b/drivers/net/mlx5/meson.build
@@ -25,6 +25,7 @@ foreach libname:libnames
 		libs += [ lib ]
 	else
 		build = false
+		reason = 'missing dependency, "' + libname + '"'
 	endif
 endforeach
 if build
diff --git a/drivers/net/mvneta/meson.build b/drivers/net/mvneta/meson.build
index c0b1bce01..8d7202788 100644
--- a/drivers/net/mvneta/meson.build
+++ b/drivers/net/mvneta/meson.build
@@ -10,6 +10,7 @@ inc_dir = path + '/include'
 lib = cc.find_library('libmusdk', dirs : [lib_dir], required: false)
 if not lib.found()
 	build = false
+	reason = 'missing dependency, "libmusdk"'
 else
 	ext_deps += lib
 	includes += include_directories(inc_dir)
diff --git a/drivers/net/mvpp2/meson.build b/drivers/net/mvpp2/meson.build
index 70ef2d642..e06eddaac 100644
--- a/drivers/net/mvpp2/meson.build
+++ b/drivers/net/mvpp2/meson.build
@@ -10,6 +10,7 @@ inc_dir = path + '/include'
 lib = cc.find_library('libmusdk', dirs : [lib_dir], required: false)
 if not lib.found()
 	build = false
+	reason = 'missing dependency, "libmusdk"'
 else
 	ext_deps += lib
 	includes += include_directories(inc_dir)
diff --git a/drivers/net/netvsc/meson.build b/drivers/net/netvsc/meson.build
index c84269716..e9fe35344 100644
--- a/drivers/net/netvsc/meson.build
+++ b/drivers/net/netvsc/meson.build
@@ -2,6 +2,7 @@
 # Copyright(c) 2018 Microsoft Corporation
 
 build = dpdk_conf.has('RTE_LIBRTE_VMBUS_BUS')
+reason = 'missing dependency, DPDK VMBus driver'
 version = 2
 sources = files('hn_ethdev.c', 'hn_rxtx.c', 'hn_rndis.c', 'hn_nvs.c', 'hn_vf.c')
 
diff --git a/drivers/net/nfb/meson.build b/drivers/net/nfb/meson.build
index 457955d72..4502c3f76 100644
--- a/drivers/net/nfb/meson.build
+++ b/drivers/net/nfb/meson.build
@@ -4,6 +4,7 @@
 # All rights reserved.
 
 dep = cc.find_library('nfb', required: false)
+reason = 'missing dependency, "libnfb"'
 
 build = dep.found() and cc.has_header('nfb/nfb.h', dependencies: dep)
 
diff --git a/drivers/net/nfp/meson.build b/drivers/net/nfp/meson.build
index 8c87c5b0b..b487cdffd 100644
--- a/drivers/net/nfp/meson.build
+++ b/drivers/net/nfp/meson.build
@@ -2,7 +2,8 @@
 # Copyright(c) 2018 Intel Corporation
 
 if not is_linux or not dpdk_conf.get('RTE_ARCH_64')
-        build = false
+	build = false
+	reason = 'only supported on 64-bit linux'
 endif
 sources = files('nfpcore/nfp_cpp_pcie_ops.c',
 	'nfpcore/nfp_nsp.c',
diff --git a/drivers/net/pcap/meson.build b/drivers/net/pcap/meson.build
index 2c2fd11e4..910dfab9b 100644
--- a/drivers/net/pcap/meson.build
+++ b/drivers/net/pcap/meson.build
@@ -14,6 +14,7 @@ else
 		pkgconfig_extra_libs += '-lpcap'
 	else
 		build = false
+		reason = 'missing dependency, "libpcap"'
 	endif
 endif
 sources = files('rte_eth_pcap.c')
diff --git a/drivers/net/sfc/meson.build b/drivers/net/sfc/meson.build
index e67560991..4fb0d0ac1 100644
--- a/drivers/net/sfc/meson.build
+++ b/drivers/net/sfc/meson.build
@@ -8,6 +8,7 @@
 
 if arch_subdir != 'x86' or not dpdk_conf.get('RTE_ARCH_64')
 	build = false
+	reason = 'only supported on x86_64'
 endif
 
 allow_experimental_apis = true
diff --git a/drivers/net/softnic/meson.build b/drivers/net/softnic/meson.build
index dd1d610ea..9c10c2ec8 100644
--- a/drivers/net/softnic/meson.build
+++ b/drivers/net/softnic/meson.build
@@ -2,7 +2,8 @@
 # Copyright(c) 2018 Intel Corporation
 
 if not is_linux
-        build = false
+	build = false
+	reason = 'only supported on linux'
 endif
 allow_experimental_apis = true
 install_headers('rte_eth_softnic.h')
diff --git a/drivers/net/szedata2/meson.build b/drivers/net/szedata2/meson.build
index da3733743..032b42518 100644
--- a/drivers/net/szedata2/meson.build
+++ b/drivers/net/szedata2/meson.build
@@ -3,5 +3,6 @@
 
 dep = cc.find_library('sze2', required: false)
 build = dep.found()
+reason = 'missing dependency, "libsze2"'
 ext_deps += dep
 sources = files('rte_eth_szedata2.c')
diff --git a/drivers/net/tap/meson.build b/drivers/net/tap/meson.build
index c407a1f35..baa70f756 100644
--- a/drivers/net/tap/meson.build
+++ b/drivers/net/tap/meson.build
@@ -2,7 +2,8 @@
 # Copyright 2018 Luca Boccassi <bluca@debian.org>
 
 if not is_linux
-        build = false
+	build = false
+	reason = 'only supported on linux'
 endif
 sources = files(
 	'rte_eth_tap.c',
diff --git a/drivers/net/vdev_netvsc/meson.build b/drivers/net/vdev_netvsc/meson.build
index 6655859f8..c82c5476c 100644
--- a/drivers/net/vdev_netvsc/meson.build
+++ b/drivers/net/vdev_netvsc/meson.build
@@ -2,7 +2,8 @@
 # Copyright(c) 2018 Luca Boccassi <bluca@debian.org>
 
 if not is_linux
-        build = false
+	build = false
+	reason = 'only supported on linux'
 endif
 sources = files('vdev_netvsc.c')
 
diff --git a/drivers/net/vhost/meson.build b/drivers/net/vhost/meson.build
index 9b067c35e..9532a7605 100644
--- a/drivers/net/vhost/meson.build
+++ b/drivers/net/vhost/meson.build
@@ -2,6 +2,7 @@
 # Copyright(c) 2018 Intel Corporation
 
 build = dpdk_conf.has('RTE_LIBRTE_VHOST')
+reason = 'missing dependency, DPDK vhost library'
 version = 2
 sources = files('rte_eth_vhost.c')
 install_headers('rte_eth_vhost.h')